#ifndef __NETWORK_INTERFACE__
#define __NETWORK_INTERFACE__

#include <pthread.h>
#include <unistd.h>

#include "websocket_handler.h"

#define PORT 9000
#define TIMEWAIT 100
#define BUFFLEN 2048
#define MAXEVENTSSIZE 20

class Network_Interface
{
private:
	Network_Interface();

	int init();
	int epoll_loop();
	int set_noblock(int fd);
	void ctl_event(int fd, bool flag);

public:
	void run();
	static Network_Interface *getInstance();

private:
	class CGarbo{
	public:
		~CGarbo()
		{
			if (m_network_interface != 0)
			{
				delete m_network_interface;
				m_network_interface = 0;
			}
		}
	};

	static CGarbo m_garbo;
	static Network_Interface *m_network_interface;

	typedef std::map<int, Websocket_Handler *> WEB_SOCKET_HANDLER_MAP;
	 WEB_SOCKET_HANDLER_MAP m_websocket_handler_map;

	int epollfd_;
	int listenfd_;
};

#define NETWORK_INTERFACE Network_Interface::getInstance()

#endif
