#include <unistd.h>
#include "websocket_handler.h"
#include "WebSocketProtocol.h"

Websocket_Handler::Websocket_Handler(int fd) :
buff_(),
status_(WEBSOCKET_UNCONNECT),
fd_(fd),
request_(new Websocket_Request)
{
}

Websocket_Handler::~Websocket_Handler(){
	if (request_ != NULL)
	{
		delete request_;
		request_ = NULL;
	}
}

int Websocket_Handler::handshake(){

	status_ = WEBSOCKET_HANDSHAKEED;

	std::string requestr(buff_);
	std::string response;

	CWebSocketProtocol::getInstance()->getResponseHttp(requestr, response);

	return send_data(response.c_str());
}

int Websocket_Handler::send_data(const char *buff){
	return write(fd_, buff, strlen(buff));
}

int Websocket_Handler::process(){
	if (status_ == WEBSOCKET_UNCONNECT)
	{
		return handshake();
	}

#if 0	//debug
	request_->fetch_websocket_info(buff_);
	request_->print();
#endif

	CWebSocketProtocol::getInstance()->wsDecodeFrame(buff_, m_requestCmd);	//Ϣ

#if 1	//debug
	std::string responseStr = "{\"result\":\"OK\",\"data\":{\"A1\":\"a1\",\"A2\":\"a2\"}}";
	std::string responseMsg;

	CWebSocketProtocol::getInstance()->wsEncodeFrame(
		responseStr, 
		responseMsg, 
		CWebSocketProtocol::WS_TEXT_FRAME);		//뷢͵Ϣ

	send_data(responseMsg.c_str());
#endif
	memset(buff_, 0, sizeof(buff_));

	return 0;
}