#ifndef __WEBSOCKET_HANDLER__
#define __WEBSOCKET_HANDLER__

#include <arpa/inet.h>
#include <iostream>
#include <map>
#include <sstream>
#include "base64.h"
#include "sha1.h"
#include "debug_log.h"
#include "websocket_request.h"

enum WEBSOCKET_STATUS {
	WEBSOCKET_UNCONNECT = 0,
	WEBSOCKET_HANDSHAKEED = 1,
};

class Websocket_Handler{
public:
	Websocket_Handler(int fd);
	~Websocket_Handler();

	int process();
	inline char *getbuff();
	int send_data(const char *buff);

	void clearRequestCmd()
	{
		m_requestCmd = "";
	}

	const std::string & getRequestCmd() const
	{
		return m_requestCmd;
	}

private:

	int handshake();

private:
	char buff_[2048];
	std::string m_requestCmd;	//ָ

	WEBSOCKET_STATUS status_;
	int fd_;
	Websocket_Request *request_;
};

inline char *Websocket_Handler::getbuff(){
	return buff_;
}

#endif
